
Efl_Object *_efl_ui_scroller_efl_object_constructor(Eo *obj, Efl_Ui_Scroller_Data *pd);


Efl_Object *_efl_ui_scroller_efl_object_finalize(Eo *obj, Efl_Ui_Scroller_Data *pd);


void _efl_ui_scroller_efl_object_destructor(Eo *obj, Efl_Ui_Scroller_Data *pd);


void _efl_ui_scroller_efl_object_invalidate(Eo *obj, Efl_Ui_Scroller_Data *pd);


Eina_Bool _efl_ui_scroller_efl_content_content_set(Eo *obj, Efl_Ui_Scroller_Data *pd, Efl_Gfx_Entity *content);


Efl_Gfx_Entity *_efl_ui_scroller_efl_content_content_get(const Eo *obj, Efl_Ui_Scroller_Data *pd);


Efl_Gfx_Entity *_efl_ui_scroller_efl_content_content_unset(Eo *obj, Efl_Ui_Scroller_Data *pd);


void _efl_ui_scroller_efl_canvas_group_group_calculate(Eo *obj, Efl_Ui_Scroller_Data *pd);


Eina_Error _efl_ui_scroller_efl_ui_widget_theme_apply(Eo *obj, Efl_Ui_Scroller_Data *pd);


Eina_Bool _efl_ui_scroller_efl_ui_widget_focus_state_apply(Eo *obj, Efl_Ui_Scroller_Data *pd, Efl_Ui_Widget_Focus_State current_state, Efl_Ui_Widget_Focus_State *configured_state, Efl_Ui_Widget *redirect);


Eina_Bool _efl_ui_scroller_efl_ui_widget_widget_input_event_handler(Eo *obj, Efl_Ui_Scroller_Data *pd, const Efl_Event *eo_event, Efl_Canvas_Object *source);


Efl_Ui_Focus_Manager *_efl_ui_scroller_efl_ui_widget_focus_manager_focus_manager_create(Eo *obj, Efl_Ui_Scroller_Data *pd, Efl_Ui_Focus_Object *root);


void _efl_ui_scroller_efl_ui_scrollable_match_content_set(Eo *obj, Efl_Ui_Scroller_Data *pd, Eina_Bool w, Eina_Bool h);


static Eina_Bool
_efl_ui_scroller_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_SCROLLER_EXTRA_OPS
#define EFL_UI_SCROLLER_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_scroller_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_finalize, _efl_ui_scroller_efl_object_finalize),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_ui_scroller_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_invalidate, _efl_ui_scroller_efl_object_invalidate),
      EFL_OBJECT_OP_FUNC(efl_content_set, _efl_ui_scroller_efl_content_content_set),
      EFL_OBJECT_OP_FUNC(efl_content_get, _efl_ui_scroller_efl_content_content_get),
      EFL_OBJECT_OP_FUNC(efl_content_unset, _efl_ui_scroller_efl_content_content_unset),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_calculate, _efl_ui_scroller_efl_canvas_group_group_calculate),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_theme_apply, _efl_ui_scroller_efl_ui_widget_theme_apply),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_focus_state_apply, _efl_ui_scroller_efl_ui_widget_focus_state_apply),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_input_event_handler, _efl_ui_scroller_efl_ui_widget_widget_input_event_handler),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_focus_manager_create, _efl_ui_scroller_efl_ui_widget_focus_manager_focus_manager_create),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_match_content_set, _efl_ui_scroller_efl_ui_scrollable_match_content_set),
      EFL_UI_SCROLLER_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_scroller_class_desc = {
   EO_VERSION,
   "Efl.Ui.Scroller",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Ui_Scroller_Data),
   _efl_ui_scroller_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_scroller_class_get, &_efl_ui_scroller_class_desc, EFL_UI_LAYOUT_BASE_CLASS, EFL_UI_FOCUS_MANAGER_SUB_MIXIN, EFL_UI_WIDGET_FOCUS_MANAGER_MIXIN, EFL_CONTENT_INTERFACE, EFL_UI_SCROLLABLE_INTERFACE, EFL_UI_SCROLLBAR_INTERFACE, NULL);
